SystemOrganization addCategory: #'GT-Tests-Spotter'!
SystemOrganization addCategory: 'GT-Tests-Spotter-Exceptions'!
SystemOrganization addCategory: 'GT-Tests-Spotter-Exceptions-Mocks'!
SystemOrganization addCategory: 'GT-Tests-Spotter-Scripting'!
SystemOrganization addCategory: 'GT-Tests-Spotter-Scripting-Mocks'!

TestCase subclass: #GTSpotterA1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter'!

TestCase subclass: #GTSpotterA2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter'!

TestCase subclass: #GTSpotterA3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter'!

TestCase subclass: #GTSpotterCandidatesListTest
	instanceVariableNames: 'candidates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter'!

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/24/2014 20:42'!
addCategories: aCollection

	aCollection do: [ :each | candidates addProcessor: each ]! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/24/2014 20:52'!
hasCategories: aCollection
	|counter|
	candidates processors asArray size = aCollection size ifFalse: [ ^ false ].
	counter := 1.
	candidates processors asArray
		do: [ :each | (each = (aCollection at: counter)) ifFalse: [ ^ false ] . counter := counter + 1].
	^ true! !

!GTSpotterCandidatesListTest methodsFor: 'running' stamp: 'TudorGirba 11/26/2014 14:34'!
setUp

	candidates := GTSpotterCandidatesList new.! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:06'!
testAddCategories
	|categories|
	categories := { GTSpotterA1 . GTSpotterA2 . GTSpotterA3 }.
	
	self addCategories: categories.
	self assert: (self hasCategories: categories)! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:06'!
testAddOneCandidateA1
	|link category|
	
	category := candidates addProcessor: GTSpotterA1.
	link := candidates addCandidate: 11 in: GTSpotterA1.
	
	self assert: (link nextLink = link).
	self assert: (link previousLink = link).
	self assert: (candidates head = link).
	self assert: (candidates tail = link).
	self assert: ((category headLink) = link).
	self assert: ((category tailLink) = link).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:06'!
testAddOneCandidateA1A2
	|link11 link21 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	
	self assert: (link11 nextLink = link21).
	self assert: (link11 previousLink = link21).
	
	self assert: (link21 nextLink = link11).
	self assert: (link21 previousLink = link11).
	
	self assert: (candidates head = link11).
	self assert: (candidates tail = link21).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link11).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link21).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:07'!
testAddOneCandidateA1A2A3
	|link11 link21 link31 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link31 := candidates addCandidate: 31 in: GTSpotterA3.
	
	self assert: (link11 nextLink = link21).
	self assert: (link11 previousLink = link31).
	
	self assert: (link21 nextLink = link31).
	self assert: (link21 previousLink = link11).
	
	self assert: (link31 nextLink = link11).
	self assert: (link31 previousLink = link21).
		
	self assert: (candidates head = link11).
	self assert: (candidates tail = link31).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link11).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link21).
	
	self assert: ((category3 headLink) = link31).
	self assert: ((category3 tailLink) = link31).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:07'!
testAddThreeCandidateA1
	|link1 link2 link3 category|
	
	category := candidates addProcessor: GTSpotterA1.
	link1 := candidates addCandidate: 11 in: GTSpotterA1.
	link2 := candidates addCandidate: 12 in: GTSpotterA1.
	link3 := candidates addCandidate: 13 in: GTSpotterA1.
	
	self assert: (link1 nextLink = link2).
	self assert: (link1 previousLink = link3).
	
	self assert: (link2 nextLink = link3).
	self assert: (link2 previousLink = link1).
	
	self assert: (link3 nextLink = link1).
	self assert: (link3 previousLink = link2).
	
	self assert: (candidates head = link1).
	self assert: (candidates tail = link3).
	self assert: ((category headLink) = link1).
	self assert: ((category tailLink) = link3).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:07'!
testAddThreeCandidateA1A2
	|link11 link12 link13 link21 link22 link23 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	
	self assert: (link11 nextLink = link12).
	self assert: (link11 previousLink = link23).
	
	self assert: (link12 nextLink = link13).
	self assert: (link12 previousLink = link11).
	
	self assert: (link13 nextLink = link21).
	self assert: (link13 previousLink = link12).
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link13).
	
	self assert: (link22 nextLink = link23).
	self assert: (link22 previousLink = link21).
	
	self assert: (link23 nextLink = link11).
	self assert: (link23 previousLink = link22).
	
	self assert: (candidates head = link11).
	self assert: (candidates tail = link23).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link13).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link23).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:07'!
testAddThreeCandidateA1A2A3
	|link11 link12 link13 link21 link22 link23 link31 link32 link33 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	link31 := candidates addCandidate: 31 in: GTSpotterA3.
	link32 := candidates addCandidate: 32 in: GTSpotterA3.
	link33 := candidates addCandidate: 33 in: GTSpotterA3.
	
	self assert: (link11 nextLink = link12).
	self assert: (link11 previousLink = link33).
	
	self assert: (link12 nextLink = link13).
	self assert: (link12 previousLink = link11).
	
	self assert: (link13 nextLink = link21).
	self assert: (link13 previousLink = link12).
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link13).
	
	self assert: (link22 nextLink = link23).
	self assert: (link22 previousLink = link21).
	
	self assert: (link23 nextLink = link31).
	self assert: (link23 previousLink = link22).
	
	self assert: (link31 nextLink = link32).
	self assert: (link31 previousLink = link23).
	
	self assert: (link32 nextLink = link33).
	self assert: (link32 previousLink = link31).
	
	self assert: (link33 nextLink = link11).
	self assert: (link33 previousLink = link32).
		
	self assert: (candidates head = link11).
	self assert: (candidates tail = link33).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link13).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link23).
	
	self assert: ((category3 headLink) = link31).
	self assert: ((category3 tailLink) = link33).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:08'!
testAddThreeCandidateA1A2A3Shuffled
	|link11 link12 link13 link21 link22 link23 link31 link32 link33 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link31 := candidates addCandidate: 31 in: GTSpotterA3.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link32 := candidates addCandidate: 32 in: GTSpotterA3.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	link33 := candidates addCandidate: 33 in: GTSpotterA3.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	
	self assert: (link11 nextLink = link12).
	self assert: (link11 previousLink = link33).
	
	self assert: (link12 nextLink = link13).
	self assert: (link12 previousLink = link11).
	
	self assert: (link13 nextLink = link21).
	self assert: (link13 previousLink = link12).
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link13).
	
	self assert: (link22 nextLink = link23).
	self assert: (link22 previousLink = link21).
	
	self assert: (link23 nextLink = link31).
	self assert: (link23 previousLink = link22).
	
	self assert: (link31 nextLink = link32).
	self assert: (link31 previousLink = link23).
	
	self assert: (link32 nextLink = link33).
	self assert: (link32 previousLink = link31).
	
	self assert: (link33 nextLink = link11).
	self assert: (link33 previousLink = link32).
		
	self assert: (candidates head = link11).
	self assert: (candidates tail = link33).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link13).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link23).
	
	self assert: ((category3 headLink) = link31).
	self assert: ((category3 tailLink) = link33).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:08'!
testAddTwoCandidateA1
	|link1 link2 category|
	
	category := candidates addProcessor: GTSpotterA1.
	link1 := candidates addCandidate: 11 in: GTSpotterA1.
	link2 := candidates addCandidate: 12 in: GTSpotterA1.
	
	self assert: (link1 nextLink = link2).
	self assert: (link1 previousLink = link2).
	
	self assert: (link2 nextLink = link1).
	self assert: (link2 previousLink = link1).
	
	self assert: (candidates head = link1).
	self assert: (candidates tail = link2).
	self assert: ((category headLink) = link1).
	self assert: ((category tailLink) = link2).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:08'!
testAddTwoCandidateA1A2
	|link11 link12 link21 link22 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	
	self assert: (link11 nextLink = link12).
	self assert: (link11 previousLink = link22).
	
	self assert: (link12 nextLink = link21).
	self assert: (link12 previousLink = link11).
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link12).
	
	self assert: (link22 nextLink = link11).
	self assert: (link22 previousLink = link21).
	
	self assert: (candidates head = link11).
	self assert: (candidates tail = link22).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link12).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link22).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:09'!
testAddTwoCandidateA1A2A3
	|link11 link12 link21 link22 link31 link32 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link31 := candidates addCandidate: 31 in: GTSpotterA3.
	link32 := candidates addCandidate: 32 in: GTSpotterA3.
	
	self assert: (link11 nextLink = link12).
	self assert: (link11 previousLink = link32).
	
	self assert: (link12 nextLink = link21).
	self assert: (link12 previousLink = link11).
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link12).
	
	self assert: (link22 nextLink = link31).
	self assert: (link22 previousLink = link21).
	
	self assert: (link31 nextLink = link32).
	self assert: (link31 previousLink = link22).
	
	self assert: (link32 nextLink = link11).
	self assert: (link32 previousLink = link31).
		
	self assert: (candidates head = link11).
	self assert: (candidates tail = link32).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link12).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link22).
	
	self assert: ((category3 headLink) = link31).
	self assert: ((category3 tailLink) = link32).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:09'!
testCategoryLinkByCandidateLinkThreeA1A2A3
	|link11 link12 link13 link21 link22 link23 link31 link32 link33 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	link31 := candidates addCandidate: 31 in: GTSpotterA3.
	link32 := candidates addCandidate: 32 in: GTSpotterA3.
	link33 := candidates addCandidate: 33 in: GTSpotterA3.
	
	self assert: (category1 = (candidates getProcessorLinkByCandidateLink: link11)).
	self assert: (category1 = (candidates getProcessorLinkByCandidateLink: link12)).
	self assert: (category1 = (candidates getProcessorLinkByCandidateLink: link13)).
	
	self assert: (category2 = (candidates getProcessorLinkByCandidateLink: link21)).
	self assert: (category2 = (candidates getProcessorLinkByCandidateLink: link22)).
	self assert: (category2 = (candidates getProcessorLinkByCandidateLink: link23)).
	
	self assert: (category3 = (candidates getProcessorLinkByCandidateLink: link31)).
	self assert: (category3 = (candidates getProcessorLinkByCandidateLink: link32)).
	self assert: (category3 = (candidates getProcessorLinkByCandidateLink: link33)).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:10'!
testNextA1A2Category

	|link11 link12 link13 link21 link22 link23 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	
	self assert: (category1 = (candidates nextProcessorLinkOf: category2)).
	self assert: (category2 = (candidates nextProcessorLinkOf: category1)).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:10'!
testNextA1A2EmptyCategory

	|link11 link12 link13 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	
	self assert: (category1 = (candidates nextProcessorLinkOf: category1)).
	self assert: (category1 = (candidates nextProcessorLinkOf: category2)).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:10'!
testNextA1Category

	|link11 link12 link13 category1 |
	
	category1 := candidates addProcessor: GTSpotterA1.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	
	self assert: (category1 = (candidates nextProcessorLinkOf: category1)).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:10'!
testPreviousA1A2Category

	|link11 link12 link13 link21 link22 link23 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	
	self assert: (category1 = (candidates previousProcessorLinkOf: category2)).
	self assert: (category2 = (candidates previousProcessorLinkOf: category1)).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:11'!
testPreviousA1A2EmptyCategory

	|link11 link12 link13 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	
	self assert: (category1 = (candidates previousProcessorLinkOf: category1)).
	self assert: (category1 = (candidates previousProcessorLinkOf: category2)).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:11'!
testPreviousA1Category

	|link11 link12 link13 category1 |
	
	category1 := candidates addProcessor: GTSpotterA1.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	
	self assert: (category1 = (candidates previousProcessorLinkOf: category1)).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:11'!
testRemoveCandidatesA1A2A3FromA1A2A3
	|category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	candidates addCandidate: 11 in: GTSpotterA1.
	candidates addCandidate: 12 in: GTSpotterA1.
	candidates addCandidate: 13 in: GTSpotterA1.
	candidates addCandidate: 21 in: GTSpotterA2.
	candidates addCandidate: 22 in: GTSpotterA2.
	candidates addCandidate: 23 in: GTSpotterA2.
	candidates addCandidate: 31 in: GTSpotterA3.
	candidates addCandidate: 32 in: GTSpotterA3.
	candidates addCandidate: 33 in: GTSpotterA3.
	
	candidates removeAllCandidatesOf: GTSpotterA1.
	candidates removeAllCandidatesOf: GTSpotterA3.
	candidates removeAllCandidatesOf: GTSpotterA2.
			
	self assert: (candidates head = nil).
	self assert: (candidates tail = nil).
	
	self assert: ((category1 headLink) = nil).
	self assert: ((category1 tailLink) = nil).
	
	self assert: ((category2 headLink) = nil).
	self assert: ((category2 tailLink) = nil).
	
	self assert: ((category3 headLink) = nil).
	self assert: ((category3 tailLink) = nil).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:12'!
testRemoveCandidatesA1A3FromA1A2A3
	|link21 link22 link23 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	candidates addCandidate: 11 in: GTSpotterA1.
	candidates addCandidate: 12 in: GTSpotterA1.
	candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	candidates addCandidate: 31 in: GTSpotterA3.
	candidates addCandidate: 32 in: GTSpotterA3.
	candidates addCandidate: 33 in: GTSpotterA3.
	
	candidates removeAllCandidatesOf: GTSpotterA1.
	candidates removeAllCandidatesOf: GTSpotterA3.
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link23).
	
	self assert: (link22 nextLink = link23).
	self assert: (link22 previousLink = link21).
	
	self assert: (link23 nextLink = link21).
	self assert: (link23 previousLink = link22).
		
	self assert: (candidates head = link21).
	self assert: (candidates tail = link23).
	
	self assert: ((category1 headLink) = nil).
	self assert: ((category1 tailLink) = nil).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link23).
	
	self assert: ((category3 headLink) = nil).
	self assert: ((category3 tailLink) = nil).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:12'!
testRemoveCandidatesA1FromA1A2A3
	|link21 link22 link23 link31 link32 link33 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	candidates addCandidate: 11 in: GTSpotterA1.
	candidates addCandidate: 12 in: GTSpotterA1.
	candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	link31 := candidates addCandidate: 31 in: GTSpotterA3.
	link32 := candidates addCandidate: 32 in: GTSpotterA3.
	link33 := candidates addCandidate: 33 in: GTSpotterA3.
	
	candidates removeAllCandidatesOf: GTSpotterA1.
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link33).
	
	self assert: (link22 nextLink = link23).
	self assert: (link22 previousLink = link21).
	
	self assert: (link23 nextLink = link31).
	self assert: (link23 previousLink = link22).
	
	self assert: (link31 nextLink = link32).
	self assert: (link31 previousLink = link23).
	
	self assert: (link32 nextLink = link33).
	self assert: (link32 previousLink = link31).
	
	self assert: (link33 nextLink = link21).
	self assert: (link33 previousLink = link32).
		
	self assert: (candidates head = link21).
	self assert: (candidates tail = link33).
	
	self assert: ((category1 headLink) = nil).
	self assert: ((category1 tailLink) = nil).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link23).
	
	self assert: ((category3 headLink) = link31).
	self assert: ((category3 tailLink) = link33).! !

TestCase subclass: #GTSpotterExceptionsTest
	instanceVariableNames: 'spotter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Exceptions'!

GTSpotterExceptionsTest class
	instanceVariableNames: 'exceptions fatals'!

GTSpotterExceptionsTest class
	instanceVariableNames: 'exceptions fatals'!

!GTSpotterExceptionsTest class methodsFor: 'accessing' stamp: 'StefanReichhart 3/18/2015 15:03'!
exceptions
	^ exceptions ifNil: [ exceptions := OrderedCollection new ]! !

!GTSpotterExceptionsTest class methodsFor: 'accessing' stamp: 'StefanReichhart 3/18/2015 15:33'!
fatals
	^ fatals ifNil: [ fatals := OrderedCollection new ]! !

!GTSpotterExceptionsTest class methodsFor: 'accessing' stamp: 'StefanReichhart 3/18/2015 15:33'!
reset
	exceptions := nil.
	fatals := nil.! !

!GTSpotterExceptionsTest methodsFor: 'private' stamp: 'StefanReichhart 3/18/2015 15:36'!
assertException: anErrorClass
	self deny: self class exceptions isEmpty.
	self assert: (self class exceptions anySatisfy: [ :e | e class == anErrorClass ]).
	self assert: self class fatals isEmpty.! !

!GTSpotterExceptionsTest methodsFor: 'private' stamp: 'StefanReichhart 3/18/2015 15:35'!
assertNoExceptions
	self assert: self class exceptions isEmpty.
	self assert: self class fatals isEmpty.! !

!GTSpotterExceptionsTest methodsFor: 'private' stamp: 'StefanReichhart 3/18/2015 15:37'!
assertResetExceptions
	self class reset.
	self assertNoExceptions.! !

!GTSpotterExceptionsTest methodsFor: 'private' stamp: 'StefanReichhart 3/18/2015 15:38'!
exceptionHandler: anExceptionHandler do: aBlock
	self assertResetExceptions.
	self shouldnt: [ 
		anExceptionHandler handleExceptionsDuring: aBlock ] raise: Error.
	self assertNoExceptions.
	
	self assertResetExceptions.
	self shouldnt: [ 
		spotter exceptionHandler: anExceptionHandler.
		spotter handleExceptionsDuring: aBlock ] raise: Error.
	self assertNoExceptions.! !

!GTSpotterExceptionsTest methodsFor: 'private' stamp: 'StefanReichhart 3/18/2015 13:13'!
process: aString origin: anOrigin
	| step |
	((step := GTSpotterStep new)
		spotter: spotter;
		origin: anOrigin;
		yourself) processContext: (step newContextForQuery: aString)! !

!GTSpotterExceptionsTest methodsFor: 'running' stamp: 'StefanReichhart 3/22/2015 18:34'!
setUp
	super setUp.
	
	spotter := GTSpotter new.
	self class reset.! !

!GTSpotterExceptionsTest methodsFor: 'private' stamp: 'StefanReichhart 3/18/2015 13:30'!
shouldRaise: anError process: aString origin: anOrigin
	self shouldRaise: anError process: aString origin: anOrigin do: [ :exception | ]! !

!GTSpotterExceptionsTest methodsFor: 'private' stamp: 'StefanReichhart 3/22/2015 18:34'!
shouldRaise: anError process: aString origin: anOrigin do: aBlock
	self shouldRaise: anError process: aString origin: anOrigin during: GTSpotterDebuggingExceptionHandlerMock new do: aBlock! !

!GTSpotterExceptionsTest methodsFor: 'private' stamp: 'StefanReichhart 3/18/2015 14:11'!
shouldRaise: anErrorClass process: aString origin: anOrigin during: exceptionHandler
	self shouldRaise: anErrorClass process: aString origin: anOrigin during: exceptionHandler do: [ :e | ]! !

!GTSpotterExceptionsTest methodsFor: 'private' stamp: 'StefanReichhart 3/18/2015 15:39'!
shouldRaise: anErrorClass process: aString origin: anOrigin during: exceptionHandler do: aBlock
	self assertResetExceptions.

	spotter exceptionHandler: exceptionHandler.
	self assert: spotter exceptionHandler == exceptionHandler.
	
	self should: [ self process: aString origin: anOrigin ] 
		raise: anErrorClass 
		withExceptionDo: [ :exception | 
			self assert: exception class == anErrorClass.
			aBlock value: exception. ].
		
	self assert: spotter exceptionHandler == exceptionHandler.
	
	self assertException: anErrorClass! !

!GTSpotterExceptionsTest methodsFor: 'private' stamp: 'StefanReichhart 3/22/2015 18:34'!
shouldntRaise: anError process: aString origin: anOrigin
	self shouldntRaise: anError process: aString origin: anOrigin during: GTSpotterDeploymentExceptionHandlerMock new! !

!GTSpotterExceptionsTest methodsFor: 'private' stamp: 'StefanReichhart 3/18/2015 15:43'!
shouldntRaise: anError process: aString origin: anOrigin during: exceptionHandler
	spotter exceptionHandler: exceptionHandler.
	self assert: spotter exceptionHandler == exceptionHandler.
	
	self shouldnt: [ self process: aString origin: anOrigin ] raise: anError.
	
	self assert: spotter exceptionHandler == exceptionHandler.! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:47'!
testDebuggingExceptionHandlerDuring
	| exceptionHandler |
	
	self exceptionHandler: (exceptionHandler := GTSpotterDebuggingExceptionHandlerMock new) do: [ 
		self shouldnt: [ GTCurrentSpotterExceptionHandler value ] raise: Error.
		self assert: GTCurrentSpotterExceptionHandler value notNil.
		self assert: GTCurrentSpotterExceptionHandler value == exceptionHandler ].! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:35'!
testDebuggingExceptionHandlerMock1
	
	self shouldRaise: AssertionFailure process: 'abc' origin: GTSpotterExceptionMock1 new do: [:e | 
		self assert: e messageText = GTSpotterExceptionMock1 name ].! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:35'!
testDebuggingExceptionHandlerMock2

	self shouldRaise: MessageNotUnderstood process: 'abc' origin: GTSpotterExceptionMock2 new.! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:35'!
testDebuggingExceptionHandlerMock3

	self shouldRaise: ZeroDivide process: 'abc' origin: GTSpotterExceptionMock3 new.
! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:35'!
testDebuggingExceptionHandlerMock4

	self shouldRaise: ArithmeticError process: 'abc' origin: GTSpotterExceptionMock4 new do: [:e | 
		self assert: e messageText = 'Error while filtering' ].! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:45'!
testDebuggingExceptionHandlerMock5
	
	self assertResetExceptions.
	self shouldntRaise: AssertionFailure process: 'abc' origin: GTSpotterExceptionMock5 new during: GTSpotterDebuggingExceptionHandlerMock new.
	self assertNoExceptions.! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:47'!
testDeploymentExceptionHandlerDuring
	| exceptionHandler |
	
	self exceptionHandler: (exceptionHandler := GTSpotterDeploymentExceptionHandlerMock new) do: [ 
		self shouldnt: [ GTCurrentSpotterExceptionHandler value ] raise: Error.
		self assert: GTCurrentSpotterExceptionHandler value notNil.
		self assert: GTCurrentSpotterExceptionHandler value == exceptionHandler ].! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:35'!
testDeploymentExceptionHandlerMock1
	
	self assertResetExceptions.
	self shouldntRaise: AssertionFailure process: 'abc' origin: GTSpotterExceptionMock1 new.
	self assertException: AssertionFailure.
	
	self assertResetExceptions.
	self shouldntRaise: Error process: 'abc' origin: GTSpotterExceptionMock1 new.
	self assertException: AssertionFailure.! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:35'!
testDeploymentExceptionHandlerMock2
	
	self assertResetExceptions.	
	self shouldntRaise: MessageNotUnderstood process: 'abc' origin: GTSpotterExceptionMock2 new.
	self assertException: MessageNotUnderstood.
	
	self assertResetExceptions.
	self shouldntRaise: Error process: 'abc' origin: GTSpotterExceptionMock2 new.
	self assertException: MessageNotUnderstood.! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:35'!
testDeploymentExceptionHandlerMock3
	
	self assertResetExceptions.
	self shouldntRaise: ZeroDivide process: 'abc' origin: GTSpotterExceptionMock3 new.
	self assertException: ZeroDivide.
	
	self assertResetExceptions.
	self shouldntRaise: Error process: 'abc' origin: GTSpotterExceptionMock3 new.
	self assertException: ZeroDivide.! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:35'!
testDeploymentExceptionHandlerMock4
	
	self assertResetExceptions.
	self shouldntRaise: ArithmeticError process: 'abc' origin: GTSpotterExceptionMock4 new.
	self assertException: ArithmeticError.
	
	self assertResetExceptions.
	self shouldntRaise: Error process: 'abc' origin: GTSpotterExceptionMock4 new.
	self assertException: ArithmeticError.! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:45'!
testDeploymentExceptionHandlerMock5
	
	self assertResetExceptions.
	self shouldntRaise: AssertionFailure process: 'abc' origin: GTSpotterExceptionMock5 new during: GTSpotterDeploymentExceptionHandlerMock new.
	self assertNoExceptions.! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:35'!
testDeploymentHandleException

	self assertResetExceptions.
	self shouldnt: [ 
		[ 1 / 0 ] on: ZeroDivide do: [ :exception |
			self assert: (GTSpotterDeploymentExceptionHandlerMock new handleException: exception) notNil ] ] raise: ZeroDivide.
	self assertException: ZeroDivide.! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:35'!
testDeploymentHandleExceptionMock5
	
	self assertResetExceptions.
	self shouldnt: [ 
		[ 1 / 0 ] on: ZeroDivide do: [ :exception |
			self assert: (GTSpotterDeploymentExceptionHandlerMock5 new 
				handleException: exception 
				do: [ 7 ]) == 7 ] ] raise: ZeroDivide.
	self assertException: ZeroDivide! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:35'!
testDevelopmentHandleException

	self assertResetExceptions.
	self should: [
		[ 1 / 0 ] on: ZeroDivide do: [ :exception |
			GTSpotterDebuggingExceptionHandlerMock new handleException: exception ] ] raise: ZeroDivide.
	self assertException: ZeroDivide.! !

!GTSpotterExceptionsTest methodsFor: 'tests' stamp: 'StefanReichhart 3/22/2015 18:35'!
testDevelopmentHandleExceptionMock5

	self assertResetExceptions.
	self should: [ 
		[ 1 / 0 ] on: ZeroDivide do: [ :exception |
			GTSpotterDebuggingExceptionHandlerMock new 
				handleException: exception 
				do: [ self fail: 'Ups, we shouldnt have reached this statement' ] ] ] raise: ZeroDivide.
	self assertException: ZeroDivide! !

TestCase subclass: #GTSpotterProcessorsForExamplesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter'!

!GTSpotterProcessorsForExamplesTest methodsFor: 'running' stamp: 'StefanReichhart 11/16/2015 20:26'!
setUp
	super setUp.
	
	(Smalltalk classNamed: #GTExampleOrganizer) ifNotNil: [ :class | 
		class instance reset. 
		class stop ]! !

!GTSpotterProcessorsForExamplesTest methodsFor: 'running' stamp: 'StefanReichhart 11/16/2015 20:26'!
tearDown
	super tearDown.
	
	(Smalltalk classNamed: #GTExampleOrganizer) ifNotNil: [ :class | 
		class instance reset. 
		class start ]! !

!GTSpotterProcessorsForExamplesTest methodsFor: 'tests' stamp: 'TudorGirba 2/28/2016 22:33'!
testEachProcessor
	Object withAllSubclasses
		do: [ :eachClass |
			eachClass gtExamples do: [ :exampleToTest |
				exampleToTest ignoreTest ifFalse: [ 
					self 
						shouldnt: [
							| step |
							(step := GTSpotterStep new)
								spotter: (GTSpotter new
									exceptionHandler: GTSpotterDebuggingExceptionHandler new; " we want to know whether one of the processors is raising an exception "
									yourself);
								origin: exampleToTest " do don't use #result here anymore, because it is not our responsibility to check whether an example runs sucessfully or not ";
								processContext: (step newContextForQuery: 'a') ] 
						raise: Error.
					exampleToTest detachResultFromSystem " just to be sure " ] ]  ]
		displayingProgress: 'Testing GTSpotter examples (#testEachProcessor)'! !

TestCase subclass: #GTSpotterSmokeTest
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter'!

!GTSpotterSmokeTest methodsFor: 'running' stamp: 'AliakseiSyrel 1/30/2015 17:35'!
setUp
	super setUp.
	
	! !

!GTSpotterSmokeTest methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 1/30/2015 17:43'!
tearDown
	super tearDown.
	
	window ifNotNil: [ window delete ]! !

!GTSpotterSmokeTest methodsFor: 'tests' stamp: 'AliakseiSyrel 1/30/2015 17:43'!
testOpen

	window := (GTSpotterMorph new spotterModel: GTSpotter new; showPreview; yourself) extent: 500@500; openInWorld.! !

TestCase subclass: #GTSpotterStepTest
	instanceVariableNames: 'spotter currentStep previousStep currentProcessor currentCandidate currentContext previousContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Scripting'!

GTSpotterStepTest subclass: #GTSpotterStepFilteringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Scripting'!

!GTSpotterStepFilteringTest methodsFor: 'running' stamp: 'AndreiChis 9/24/2015 18:47'!
"protocol: running"
setUp
	super setUp.
	
	"Reser the state of spotter as the filter nees to be set before running a query."
	spotter := GTMockSpotter new.
	currentStep := currentProcessor := currentCandidate := nil! !

!GTSpotterStepFilteringTest methodsFor: 'tests' stamp: 'AndreiChis 9/24/2015 18:49'!
testProcessorsFiltering

	spotter filterByMethods: {
		GTSpotter>>#spotterImplementorsFor:.
		GTSpotter>>#spotterForPragmasFor:}.

	self shouldnt: [ spotter setText: '' from: self ] raise: Error. 
	
	self assertSearch: ' '.
	self assertProcessorByTitle: 'Pragmas'.
	self assertProcessorByTitle: 'Implementors'.

	self assert: currentStep processors size equals: 2.
	! !

!GTSpotterStepTest methodsFor: 'convenience' stamp: 'StefanReichhart 3/12/2015 15:39'!
assertCandidateMatching: aBlock
	| candidates |
	self assert: currentProcessor notNil.
	
	candidates := currentProcessor allFilteredCandidates select: [ :each | aBlock value: each ].
	
	self deny: candidates isEmpty.
	self assert: candidates size = 1.
	
	currentCandidate := candidates anyOne.
	self assert: currentCandidate notNil.
	
	^ currentCandidate! !

!GTSpotterStepTest methodsFor: 'convenience' stamp: 'StefanReichhart 3/12/2015 15:43'!
assertDiveIn
	self assertDiveIn: #diveIn! !

!GTSpotterStepTest methodsFor: 'private' stamp: 'AliakseiSyrel 3/22/2016 21:16'!
assertDiveIn: aSelector
	| previousStepsSize link |
	" backup previous conditions "
	previousStepsSize := spotter steps size.
	previousStep := spotter currentStep.

	" get and validate the link "
	link := spotter currentStep candidates getCandidateLink: currentCandidate in: currentProcessor.
	
	self assert: link notNil.
	self assert: link candidate == currentCandidate.
	self assert: link processor == currentProcessor.

	" set the selection - like the UI would do "
	self shouldnt: [ spotter currentStep selected: link ] raise: Error.
	self assert: spotter currentStep selected == link.
	
	" perform the dive operation - like the UI would do "
	self shouldnt: [ spotter currentStep perform: aSelector ] raise: Error.
	currentStep := spotter currentStep.
	currentProcessor := currentCandidate := previousContext := currentContext := nil.
	
	self deny: spotter steps isEmpty .
	self assert: spotter steps size > previousStepsSize.
	self assert: spotter steps size = (previousStepsSize + 1).
	
	self deny: previousStep = currentStep.
	self deny: previousStep = spotter currentStep.
	self assert: currentStep = spotter currentStep.! !

!GTSpotterStepTest methodsFor: 'convenience' stamp: 'StefanReichhart 3/12/2015 15:43'!
assertDiveInCategory
	self assertDiveIn: #diveInCategory! !

!GTSpotterStepTest methodsFor: 'convenience' stamp: 'StefanReichhart 3/12/2015 16:48'!
assertDiveOut
	| previousStepsSize |
	" backup previous conditions "
	previousStepsSize := spotter steps size.
	previousStep := spotter currentStep.

	" perform the dive operation - like the UI would do "
	self shouldnt: [ spotter popStep ] raise: Error.
	currentStep := spotter currentStep.
	currentProcessor := currentCandidate := previousContext := currentContext := nil.
	
	self assert: spotter steps size < previousStepsSize.
	self assert: spotter steps size = (previousStepsSize - 1).
	
	self deny: (previousStepsSize > 1 and: [ previousStep = currentStep ]).
	self deny: (previousStepsSize > 1 and: [ previousStep = spotter currentStep ]).
	self assert: currentStep = spotter currentStep.! !

!GTSpotterStepTest methodsFor: 'convenience' stamp: 'StefanReichhart 3/12/2015 15:40'!
assertProcessorByTitle: aString
	^ self assertProcessorMatching: [ :processor | processor title = aString ]! !

!GTSpotterStepTest methodsFor: 'convenience' stamp: 'StefanReichhart 3/12/2015 16:18'!
assertProcessorIncludes: anObject
	self assert: anObject notNil.
	self assert: currentProcessor notNil.
	self assert: currentProcessor allFilteredCandidates notEmpty.
	
	self assert: (currentProcessor allFilteredCandidates anySatisfy: [ :candidate | candidate = anObject ])! !

!GTSpotterStepTest methodsFor: 'convenience' stamp: 'StefanReichhart 3/12/2015 15:39'!
assertProcessorIncludesAll: aCollection
	self assert: aCollection notEmpty.
	self assert: currentProcessor notNil.
	self assert: currentProcessor allFilteredCandidates notEmpty.
	
	aCollection do: [ :each | 
		self assert: (currentProcessor allFilteredCandidates anySatisfy: [ :candidate | 
			candidate = each ]) ]! !

!GTSpotterStepTest methodsFor: 'convenience' stamp: 'StefanReichhart 3/12/2015 15:37'!
assertProcessorMatching: aBlock
	| processors |
	processors := spotter currentStep processors select: [ :each | aBlock value: each ].
	
	self assert: processors notEmpty.
	self assert: processors size = 1.
	
	currentProcessor := processors anyOne.
	self assert: currentProcessor notNil.
	
	^ currentProcessor! !

!GTSpotterStepTest methodsFor: 'convenience' stamp: 'StefanReichhart 3/12/2015 15:41'!
assertProcessorNotEmpty
	self assert: currentProcessor notNil.
	self deny: currentProcessor allFilteredCandidates isEmpty.! !

!GTSpotterStepTest methodsFor: 'convenience' stamp: 'StefanReichhart 3/12/2015 15:31'!
assertSearch: aString

	" assert conditions before search "
	self deny: (spotter currentStep context matches: aString).
	
	self basicSearch: aString.
		
	" assert conditions after search "
	self deny: previousContext == currentContext.
	self deny: previousContext == spotter currentStep context.
	self assert: spotter currentStep context text asString = aString asString! !

!GTSpotterStepTest methodsFor: 'convenience' stamp: 'StefanReichhart 3/12/2015 16:10'!
assortCandidatesSize: aNumber! !

!GTSpotterStepTest methodsFor: 'private' stamp: 'StefanReichhart 3/12/2015 17:12'!
basicSearch: aString
	
	" assert conditions before search "
	self flag: '#currentStep should be made more stable. This will fail for an empty, uninitialized spotter / but after multiple diveIn/diveOut it will be ok - inconsistent'.
	self assert: spotter currentStep == spotter currentStep.
	
	" backup preconditions "
	previousStep := spotter currentStep.
	previousContext := previousStep context.

	self shouldnt: [ spotter setText: aString from: nil ] raise: Error.
	
	" backup postconditions "
	currentStep := spotter currentStep.
	currentContext := spotter currentStep context.
	
	" assert conditions after search "
	self assert: previousStep == currentStep.! !

!GTSpotterStepTest methodsFor: 'private-navigation' stamp: 'StefanReichhart 3/12/2015 16:12'!
defaultPackages
	^ { 'GT-Spotter'. 'GT-SpotterExtensions-Core' }! !

!GTSpotterStepTest methodsFor: 'convenience' stamp: 'StefanReichhart 3/12/2015 15:14'!
denySearch: aString
	" if the new input is the same as before we do not expect a new search to be triggered . Therefore the context should not change "
	
	"self assert: (spotter currentStep context matches: aStringOrText)."
	
	self basicSearch: aString.
	
	" assert conditions after search "
	self assert: previousContext == currentContext.
	self assert: previousContext == spotter currentStep context.
	self assert: (previousContext matches: aString).! !

!GTSpotterStepTest methodsFor: 'private-navigation' stamp: 'StefanReichhart 3/12/2015 16:14'!
implementors: aSelector
	^ self implementors: aSelector inPackages: self defaultPackages! !

!GTSpotterStepTest methodsFor: 'private-navigation' stamp: 'StefanReichhart 3/12/2015 16:15'!
implementors: aSelector inPackages: anArray
	| implementors |
	implementors := OrderedCollection new.
	RPackageOrganizer default packages do: [ :package |
		anArray do: [ :packageName |
			package packageName = packageName ifTrue: [ 
				package methods do: [ :cm | 
					cm selector = implementors ifTrue: [ implementors add: cm ] ] ] ] ].
	^ implementors! !

!GTSpotterStepTest methodsFor: 'private-navigation' stamp: 'StefanReichhart 3/12/2015 16:21'!
pragma: aSelector of: aCompiledMethod
	^ aCompiledMethod pragmas 
		detect: [ :each | each keyword = aSelector ] 
		ifNone: [ nil ]! !

!GTSpotterStepTest methodsFor: 'private-navigation' stamp: 'StefanReichhart 3/12/2015 16:12'!
pragmas: aSelector
	^ self pragmas: aSelector inPackages: self defaultPackages! !

!GTSpotterStepTest methodsFor: 'private-navigation' stamp: 'MarcusDenker 6/8/2016 15:41'!
pragmas: aSelector inPackages: anArray
	| pragmas |
	pragmas := OrderedCollection new.
	RPackageOrganizer default packages do: [ :package |
		anArray do: [ :packageName |
			package packageName = packageName ifTrue: [ 
				package methods do: [ :cm | 
					cm methodClass isTrait ifFalse: [ 
						(cm pragmas 
							detect: [ :p | p keyword = aSelector ] 
							ifNone: [ nil ]) ifNotNil: [ :p | pragmas add: p ] ] ] ] ] ].
	^ pragmas! !

!GTSpotterStepTest methodsFor: 'private-navigation' stamp: 'StefanReichhart 3/12/2015 16:12'!
senders: aSelector
	^ self senders: aSelector inPackages: self defaultPackages! !

!GTSpotterStepTest methodsFor: 'private-navigation' stamp: 'StefanReichhart 3/12/2015 15:49'!
senders: aSelector inPackages: anArray
	| senders |
	senders := OrderedCollection new.
	RPackageOrganizer default packages do: [ :package |
		anArray do: [ :packageName |
			package packageName = packageName ifTrue: [ 
				package methods do: [ :cm | 
					(cm refersToLiteral: aSelector) ifTrue: [ 
						senders add: cm ] ] ] ] ].
	^ senders! !

!GTSpotterStepTest methodsFor: 'running' stamp: 'AndreiChis 9/24/2015 18:44'!
"protocol: running"
setUp
	super setUp.
	
	spotter := GTMockSpotter new.
	
	" having an assertion within the setup is ugly, but this code has to be performed before each test begins - so we do it here instead of copy/paste-ing this line to all tests - at least it never gets forgotten when new tests are defined "
	self shouldnt: [ spotter setText: '' from: self ] raise: Error. 
	
	currentStep := currentProcessor := currentCandidate := nil! !

!GTSpotterStepTest methodsFor: 'private-navigation' stamp: 'StefanReichhart 3/12/2015 15:30'!
subclassesOf: aClass filterBySubstring: aString inPackage: aPackageName
	^ (self subclassesOf: aClass inPackage: aPackageName) select: [ :each |
		each name includesSubstring: aString caseSensitive: false ]! !

!GTSpotterStepTest methodsFor: 'private-navigation' stamp: 'StefanReichhart 3/12/2015 15:30'!
subclassesOf: aClass inPackage: aPackageName
	^ (RPackageOrganizer default packages 
		detect: [ :each | each packageName = aPackageName ] 
		ifNone: [ ^ #() ]) classes intersection: aClass withAllSubclasses! !

!GTSpotterStepTest methodsFor: 'running' stamp: 'StefanReichhart 3/12/2015 14:57'!
tearDown
	super tearDown.
	
	spotter := currentStep := currentProcessor := currentCandidate := nil! !

!GTSpotterStepTest methodsFor: 'tests' stamp: 'StefanReichhart 3/12/2015 15:31'!
testContextChange
	
	self assertSearch: 'a'.
	self assert: previousContext text = ''.
	self denySearch: 'a'.
	
	self assertSearch: 'ab'.
	self assert: previousContext text = 'a'.
	self denySearch: 'ab'.
	
	self assertSearch: 'abc'.
	self assert: previousContext text = 'ab'.
	self denySearch: 'abc'.
	
	self assertSearch: 'ab'.
	self assert: previousContext text = 'abc'.
	self denySearch: 'ab'.
	
	self assertSearch: 'a'.
	self assert: previousContext text = 'ab'.
	self denySearch: 'a'.
	
	self assertSearch: ''.
	self assert: previousContext text = 'a'.
	
	self flag: 'because the decision for triggering a search is made in multiple places, an empty input will always trigger a search - this should be simplified - one place to make the decision GTSpotter>>#setText:from: <-> #Context>>#matches:'.
	self assertSearch: ''.
	self assertSearch: ''.
	! !

!GTSpotterStepTest methodsFor: 'tests' stamp: 'StefanReichhart 3/12/2015 15:04'!
testMock
	" test the mock setup - the mock objects do exactly the same as the original implementation, but we replace the asynchronous implementation by a synchronous "
	self assert: spotter class = GTMockSpotter.
	self assert: spotter newStep class = GTMockSpotterStep.
	self assert: spotter newStep asyncTask class = GTMockSpotterTask.! !

!GTSpotterStepTest methodsFor: 'tests' stamp: 'StefanReichhart 3/12/2015 15:32'!
testProcessorForClasses
	self assertSearch: 'Collection'.
	self assertProcessorByTitle: 'Classes'.
	self assertProcessorNotEmpty.
	self assertProcessorIncludesAll: (self subclassesOf: Collection 
														filterBySubstring: 'Collection' 
														inPackage: 'Collections-Abstract')! !

!GTSpotterStepTest methodsFor: 'tests' stamp: 'StefanReichhart 3/12/2015 16:31'!
testProcessorForImplementors
	| partialImplementors |
	self assertSearch: 'do:'.
	self assertProcessorByTitle: 'Implementors'.
	self assertProcessorNotEmpty.
	
	partialImplementors := (SystemNavigation default allImplementorsOf: #do:) collect: [ :rm | rm compiledMethod ].
	self assertProcessorIncludesAll: partialImplementors.
	self assert: currentProcessor allFilteredCandidates size > partialImplementors size.
	
	self assertSearch: 'size'.
	self assertProcessorByTitle: 'Implementors'.
	self assertProcessorNotEmpty.
	
	partialImplementors := (SystemNavigation default allImplementorsOf: #size) collect: [ :rm | rm compiledMethod ].
	self assertProcessorIncludesAll: partialImplementors.
	self assert: currentProcessor allFilteredCandidates size > partialImplementors size.! !

!GTSpotterStepTest methodsFor: 'tests' stamp: 'StefanReichhart 3/12/2015 15:38'!
testProcessorForPragmas
	self assertSearch: 'spotterOrder:'.
	self assertProcessorByTitle: 'Pragmas'.
	self assertProcessorNotEmpty.
	self assert: currentProcessor allFilteredCandidates size >= 1.
	self assertCandidateMatching: [ :each | each class = PragmaType and: [ each keyword = #spotterOrder: ] ]  ! !

!GTSpotterStepTest methodsFor: 'tests' stamp: 'AndreiChis 7/2/2016 13:18'!
testProcessorForPragmasThenDiveIn
	self testProcessorForPragmas.
	
	self assertDiveIn.
	
	self assertSearch: ''.

	self assertProcessorByTitle: 'Pragmas'.
	self assertProcessorNotEmpty.
	self assertProcessorIncludesAll: (self pragmas: #spotterOrder:).
		
	self assertProcessorByTitle: 'Users'.
	self assertProcessorNotEmpty.
	self assertProcessorIncludesAll: (self users: #spotterOrder:).
	
	self assertSearch: 'spotterForClassesFor:'.
	
	self assertProcessorByTitle: 'Pragmas'.
	self assertProcessorNotEmpty.
	self assertProcessorIncludes: (self pragma: #spotterOrder: of: (GTSpotter >> #spotterForClassesFor:)).
	
	self assertSearch: 'extensionsPragma'.
	
	self assertProcessorByTitle: 'Users'.
	self assertProcessorNotEmpty.
	self assertProcessorIncludes: (GTSpotter class >> #extensionsPragma).
	
	self assertSearch: 'spotterForF'.
	
	self assertProcessorByTitle: 'Pragmas'.
	self assertProcessorNotEmpty.
	self assertProcessorIncludes: (self pragma: #spotterOrder: of: (GTSpotter >> #spotterForFilesFor:)).
	self assertProcessorIncludes: (self pragma: #spotterOrder: of: (FileReference >> #spotterForFilesFor:)).
	
	self assertDiveOut.
	
	self assert: currentStep context text = 'spotterOrder:'! !

!GTSpotterStepTest methodsFor: 'tests' stamp: 'StefanReichhart 3/12/2015 17:06'!
testProcessorForPragmasThenDiveInCategory
	self testProcessorForPragmas.
	
	" diving into the category (without search) just reveals what was shown before - so this can be repeated infinitely and should return the same result each time "
	4 timesRepeat: [
		self assertDiveInCategory.
		self assertProcessorByTitle: 'Pragmas'.
		self assertProcessorNotEmpty.
		self assert: currentProcessor allFilteredCandidates size >= 1.
		self assertCandidateMatching: [ :each | each class = PragmaType and: [ each keyword = #spotterOrder: ] ]  ].
	
	4 timesRepeat: [
		self assert: currentStep context text = ''.
		self assertDiveOut ].
	
	self assert: currentStep context text = 'spotterOrder:'! !

!GTSpotterStepTest methodsFor: 'private-navigation' stamp: 'AndreiChis 7/2/2016 13:03'!
users: aSelector
	^ self users: aSelector inPackages: self defaultPackages! !

!GTSpotterStepTest methodsFor: 'private-navigation' stamp: 'AndreiChis 7/2/2016 13:05'!
users: aSelector inPackages: anArray
	| users |
	users := OrderedCollection new.
	RPackageOrganizer default packages do: [ :package |
		anArray do: [ :packageName |
			package packageName = packageName ifTrue: [ 
				package methods do: [ :cm | 
					((cm refersToLiteral: aSelector) 
						and: [ (cm hasPragmaNamed: aSelector) not ]) ifTrue: [ 
							users add: cm ] ] ] ] ].
	^ users! !

TestCase subclass: #GTSpotterTest
	instanceVariableNames: 'spotter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Scripting'!

!GTSpotterTest methodsFor: 'assertions' stamp: 'StefanReichhart 3/12/2015 09:33'!
assertText: aTextualObject
	self assertText: aTextualObject do: nil! !

!GTSpotterTest methodsFor: 'assertions' stamp: 'StefanReichhart 3/12/2015 09:41'!
assertText: aTextualObject do: aBlock
	| result |
	" self: emulate a view. Forget about a separate GTSpotterMockView. kiss :) "
	self shouldnt: [ result := spotter setText: aTextualObject from: self. ] raise: Error.
	
	self assert: result.
	self deny: spotter isEmpty.
	self deny: spotter steps isEmpty.
	
	self shouldnt: [ aBlock value ] raise: Error.
	
	! !

!GTSpotterTest methodsFor: 'tests' stamp: 'StefanReichhart 3/12/2015 09:45'!
testEmptyTextInput
	self testNewSpotter.
	
	self assertText: Text new do: [ self assert: spotter text isEmpty ].
	self assertText: (Text fromString: '') do: [ self assert: spotter text isEmpty ].
	self assertText: '' do: [ self assert: spotter text isEmpty ].
	self flag: 'currently: nil is converted to the string "nil"'
	"self assertText: nil do: [ self assert: spotter text isEmpty ]."! !

!GTSpotterTest methodsFor: 'tests' stamp: 'TudorGirba 4/10/2015 13:25'!
testHistorizingTheSameObjectRemovesPreviousOccurences
	| history |
	history := OrderedCollection new.
	spotter := GTSpotter new history: history.
	spotter historize: (GTSpotterCandidateLink new value: 42).
	self assert: history size = 1.
	spotter historize: (GTSpotterCandidateLink new value: 43).
	self assert: history size = 2.
	self assert: history first value = 43.
	self assert: history last value = 42.
	spotter historize: (GTSpotterCandidateLink new value: 42).
	self assert: history size = 2.
	self assert: history first value = 42.
	self assert: history last value = 43.
! !

!GTSpotterTest methodsFor: 'tests' stamp: 'StefanReichhart 3/12/2015 09:42'!
testInitialText
	self testNewSpotter.
	
	self flag: 'is this instvar still required ? we have context'.
	self assert: spotter getText isEmptyOrNil.
	self assert: spotter text isEmptyOrNil.
! !

!GTSpotterTest methodsFor: 'tests' stamp: 'AndreiChis 7/8/2015 14:39'!
"protocol: tests"
testInstanceCreation
	self shouldnt: [ spotter := GTMockSpotter new ] raise: Error.
	self shouldnt: [ 
		spotter := GTMockSpotter new
			exceptionHandler: GTSpotterDebuggingExceptionHandler new;
			yourself ] raise: Error.
	
	self assert: spotter notNil.
	self assert: spotter steps isEmpty.
	self deny: spotter hasMultipleSteps! !

!GTSpotterTest methodsFor: 'tests' stamp: 'AndreiChis 7/8/2015 14:38'!
testNewSpotter
	| step1 |
	self testInstanceCreation.
	
	self assert: spotter notNil.
	self assert: spotter isEmpty.
	self assert: spotter steps isEmpty.
	self deny: spotter hasMultipleSteps.
	
	self shouldnt: [ step1 := spotter currentStep ] raise: Error.
	
	self flag: '#currentStep is not always cached in spotter - especially when it is a new/empty spotter. In that case #currentStep will always return a new instance of a step. The implementation would be more polymorphic, oo-style, simpler and with much less ifTrue/ifFalse if the initial-state were regarded as a step as well (as an inst-var not in the inst-var-list of #steps). Maybe use a separate type to distinguish? GTSpotterInitialStep ... '.
	"self assert: step1 == spotter currentStep"
	
	self assert: step1 notNil.
	self assert: spotter isEmpty.
	self assert: spotter steps isEmpty.! !

GTSpotterDebuggingExceptionHandler subclass: #GTSpotterDebuggingExceptionHandlerMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Exceptions-Mocks'!

!GTSpotterDebuggingExceptionHandlerMock methodsFor: 'public' stamp: 'StefanReichhart 3/22/2015 18:36'!
handleException: anException do: aBlock
	" we don't want to perform aBlock during tests --> suppress logging to transcript "
	" we perform the #pass after we register that the exception happened - otherwise we cannot test for it later "
	GTSpotterExceptionsTest exceptions add: anException.
	anException pass! !

!GTSpotterDebuggingExceptionHandlerMock methodsFor: 'public' stamp: 'StefanReichhart 3/22/2015 18:36'!
handleFatalException: anException
	GTSpotterExceptionsTest fatals add: anException! !

GTSpotterUIThreadStream subclass: #GTMockSpotterStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Scripting-Mocks'!

!GTMockSpotterStream methodsFor: 'performing' stamp: 'StefanReichhart 3/12/2015 12:43'!
performSymbol: aSymbol withArguments: aCollection
	self receiver perform: aSymbol withEnoughArguments: aCollection! !

GTSpotter subclass: #GTMockSpotter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Scripting-Mocks'!

!GTMockSpotter methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/22/2015 18:32'!
defaultExceptionHandler
	^ GTSpotterDebuggingExceptionHandler new! !

!GTMockSpotter methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/12/2015 16:45'!
defaultPagerModel
	^ GLMMockPagerModel new! !

!GTMockSpotter methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/12/2015 14:30'!
defaultStep
	^ GTMockSpotterStep new! !

GLMPagerModel subclass: #GLMMockPagerModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Scripting-Mocks'!

!GLMMockPagerModel methodsFor: 'panes' stamp: 'StefanReichhart 3/12/2015 17:05'!
popPane: isSmooth
	self flag: 'the spotter-model will not pop its step unless the UI allows it by this call - hmmmmm'.
	self notifyPagePoped: nil! !

!GLMMockPagerModel methodsFor: 'scrolling' stamp: 'StefanReichhart 3/12/2015 17:05'!
scrollToPane: pageIndex callback: aBlock
	self flag: 'this method gets called directly from the gt-spotter model - hmmmmm'.
	aBlock value! !

GLMAsyncTask subclass: #GTMockSpotterTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Scripting-Mocks'!

!GTMockSpotterTask methodsFor: 'public' stamp: 'StefanReichhart 3/12/2015 14:32'!
execute: aBlock withArguments: aCollection callback: callbackBlock priority: aPriority delay: anIntegerMilliseconds
	" we cannot handle asynchronous processes well in tests, so just execute is synchronously "
	aBlock valueWithPossibleArgs: aCollection.
	aCollection value.! !

GTFilter subclass: #GTSpotterExceptionMock4Filter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Exceptions-Mocks'!

!GTSpotterExceptionMock4Filter methodsFor: 'public' stamp: 'StefanReichhart 3/18/2015 18:56'!
value: aSpotterContext
	ArithmeticError signal: 'Error while filtering' " Exception while filtering "! !

GTFilter subclass: #GTSpotterExceptionMock5Filter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Exceptions-Mocks'!

!GTSpotterExceptionMock5Filter methodsFor: 'public' stamp: 'StefanReichhart 3/22/2015 18:47'!
value: aSpotterContext
	" No Exceptions expected !! "
	| currentExceptionHandler |
	currentExceptionHandler := GTCurrentSpotterExceptionHandler value.
	self assert: currentExceptionHandler notNil.
	self assert: currentExceptionHandler == aSpotterContext exceptionHandler.
	self assert: currentExceptionHandler == aSpotterContext step exceptionHandler.
	self assert: currentExceptionHandler == aSpotterContext spotter exceptionHandler.
	^ #( 'done' )! !

GTSpotterDeploymentExceptionHandler subclass: #GTSpotterDeploymentExceptionHandlerMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Exceptions-Mocks'!

!GTSpotterDeploymentExceptionHandlerMock methodsFor: 'public' stamp: 'StefanReichhart 3/22/2015 18:49'!
handleException: anException do: aBlock
	" we don't want to perform aBlock during tests --> suppress logging to transcript "
	" only register the occured exception for later testing "
	GTSpotterExceptionsTest exceptions add: anException.! !

!GTSpotterDeploymentExceptionHandlerMock methodsFor: 'public' stamp: 'StefanReichhart 3/22/2015 18:41'!
handleFatalException: anException
	GTSpotterExceptionsTest fatals add: anException! !

GTSpotterDeploymentExceptionHandlerMock subclass: #GTSpotterDeploymentExceptionHandlerMock5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Exceptions-Mocks'!

!GTSpotterDeploymentExceptionHandlerMock5 methodsFor: 'public' stamp: 'StefanReichhart 3/22/2015 19:02'!
handleException: anException do: aBlock
	super handleException: anException do: aBlock. " we perform the block because mock5 should not raise any exception within aBlock "
	^ aBlock value! !

GTSpotterStep subclass: #GTMockSpotterStep
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Scripting-Mocks'!

!GTMockSpotterStep methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/12/2015 12:47'!
defaultStream
	^ GTMockSpotterStream new! !

!GTMockSpotterStep methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/12/2015 12:47'!
defaultTask
	^ GTMockSpotterTask new! !

Object subclass: #GTImplementorsSpotterMock1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter'!

!GTImplementorsSpotterMock1 methodsFor: 'public' stamp: 'DamienCassou 2/4/2015 12:22'!
doSomething! !

!GTImplementorsSpotterMock1 methodsFor: 'public' stamp: 'DamienCassou 2/4/2015 12:22'!
doSomethingElse! !

!GTImplementorsSpotterMock1 methodsFor: 'public' stamp: 'DamienCassou 2/4/2015 12:37'!
something1! !

!GTImplementorsSpotterMock1 methodsFor: 'public' stamp: 'DamienCassou 2/4/2015 12:37'!
something2! !

!GTImplementorsSpotterMock1 methodsFor: 'public' stamp: 'DamienCassou 2/4/2015 12:37'!
something3! !

!GTImplementorsSpotterMock1 methodsFor: 'public' stamp: 'DamienCassou 2/4/2015 12:37'!
something4! !

!GTImplementorsSpotterMock1 methodsFor: 'public' stamp: 'DamienCassou 2/4/2015 12:37'!
something5! !

Object subclass: #GTSpotterExceptionMock1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Exceptions-Mocks'!

!GTSpotterExceptionMock1 methodsFor: 'mocks' stamp: 'StefanReichhart 3/18/2015 13:28'!
messageText
	^ self class name! !

!GTSpotterExceptionMock1 methodsFor: 'mocks' stamp: 'StefanReichhart 3/18/2015 18:54'!
mockProcessorFor: aSpotterStep
	<spotterOrder: 1>
	AssertionFailure signal: self messageText " Exception while creating the processor "! !

Object subclass: #GTSpotterExceptionMock2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Exceptions-Mocks'!

!GTSpotterExceptionMock2 methodsFor: 'mocks' stamp: 'StefanReichhart 3/18/2015 18:55'!
mockProcessorFor: aSpotterStep
	<spotterOrder: 1>
	aSpotterStep listProcessor
		allCandidates: [ nil ]; " Exception while collecting candidates "
		itemName: [ :item | item asString ];
		filter: GTFilterSubstring! !

Object subclass: #GTSpotterExceptionMock3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Exceptions-Mocks'!

!GTSpotterExceptionMock3 methodsFor: 'mocks' stamp: 'StefanReichhart 3/18/2015 18:55'!
mockProcessorFor: aSpotterStep
	<spotterOrder: 1>
	aSpotterStep listProcessor
		allCandidates: [ #( 1 2 3 ) ];
		itemName: [ :item | item / 0 ]; " Exception while serializing candidates "
		filter: GTFilterSubstring! !

Object subclass: #GTSpotterExceptionMock4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Exceptions-Mocks'!

!GTSpotterExceptionMock4 methodsFor: 'mocks' stamp: 'StefanReichhart 3/18/2015 18:55'!
mockProcessorFor: aSpotterStep
	<spotterOrder: 1>
	aSpotterStep listProcessor
		allCandidates: [ #( 1 2 3 ) ];
		itemName: [ :item | item asString ];
		filter: GTSpotterExceptionMock4Filter " Exception while filtering "! !

Object subclass: #GTSpotterExceptionMock5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter-Exceptions-Mocks'!

!GTSpotterExceptionMock5 methodsFor: 'mocks' stamp: 'StefanReichhart 3/22/2015 18:47'!
mockProcessorFor: aSpotterStep
	" No Exceptions expected !! "
	<spotterOrder: 1>
	self assert: GTCurrentSpotterExceptionHandler value notNil.
	self assert: GTCurrentSpotterExceptionHandler value == aSpotterStep spotter exceptionHandler. 
	aSpotterStep listProcessor
		allCandidates: [
			self assert: GTCurrentSpotterExceptionHandler value notNil.
			self assert: GTCurrentSpotterExceptionHandler value == aSpotterStep spotter exceptionHandler. 
			#( 1 2 3 ) ];
		itemName: [ :item | 
			self assert: GTCurrentSpotterExceptionHandler value notNil.
			self assert: GTCurrentSpotterExceptionHandler value == aSpotterStep spotter exceptionHandler.
			item asString ];
		filter: GTSpotterExceptionMock5Filter! !

Object subclass: #GTSpotterStreamMock
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Spotter'!

!GTSpotterStreamMock methodsFor: 'as yet unclassified' stamp: 'DamienCassou 2/4/2015 12:28'!
addObject: anObject inProcessor: aProcessor
	objects add: anObject! !

!GTSpotterStreamMock methodsFor: 'as yet unclassified' stamp: 'DamienCassou 2/4/2015 12:28'!
initialize
	super initialize.
	objects := OrderedCollection new.! !

!GTSpotterStreamMock methodsFor: 'accessing' stamp: 'DamienCassou 2/4/2015 12:29'!
objects
	^ objects! !
